revit二次开发创建标高

图学二级第四题大部分是小别墅,标高几乎相同。

 这样做或许可以让刷题变的更高效(bushi!)更具趣味性(√)!

 代码如下:

using Autodesk.Revit.ApplicationServices;
using Autodesk.Revit.Attributes;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace revit_careateLevel
{
    [TransactionAttribute(TransactionMode.Manual)]
    public class Class1 : IExternalCommand
    {
        UIDocument uIDocument = null;
        Document document = null;
        public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
        {
            UIApplication uiApp = commandData.Application;
            uIDocument = uiApp.ActiveUIDocument;
            document = uIDocument.Document;

            Application application = uiApp.Application;

            using (Transaction transaction = new Transaction(document, "创建标高"))
            {
                transaction.Start();

                Level level1 = CreateLevel(0);
                level1.Name = "F1";

                Level level2 = CreateLevel(3000);
                level2.Name = "F2";

                Level level3 = CreateLevel(6000);
                level3.Name = "F3";

                Level level4 = CreateLevel(9000);
                level4.Name = "F4";

                Level level5 = CreateLevel(12000);
                level5.Name = "屋顶";

                transaction.Commit();
                TransactionStatus status = transaction.GetStatus();
                if (status.Equals(TransactionStatus.Committed))
                {
                    TaskDialog.Show("提示", "创建成功");
                }
            }


            return Result.Succeeded;
        }
        /// <summary>
        /// 创建标高和视图
        /// </summary>
        /// <param name="var">高度</param>
        /// <returns></returns>
        public Level CreateLevel(int var)
        {

            //创建标高
            Level level1 = Level.Create(document, ToFoot(var));

            //获取楼层平面
            FilteredElementCollector collector = new FilteredElementCollector(document);
            var elements1 = collector.OfClass(typeof(ViewFamilyType)).ToElements();

            ViewFamilyType viewFamilyType = null;
            foreach (var item in elements1)
            {
                viewFamilyType = item as ViewFamilyType;
                if (viewFamilyType.ViewFamily == ViewFamily.FloorPlan)
                {
                    break;

                }
            }
            //创建视图
            ViewPlan.Create(document, viewFamilyType.Id, level1.Id);
            return level1;

        }
        /// <summary>
        /// 单位转换
        /// </summary>
        /// <param name="var">毫米</param>
        /// <returns></returns>
        public double ToFoot(int var)
        {
            double L = UnitUtils.ConvertToInternalUnits(var, DisplayUnitType.DUT_MILLIMETERS);
            return L;
        }
    }
}

评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

周杰伦fans

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值